/*
 * Implémentation de la classe Mon_Message
 */
package Job_shop_chap_5_or;

import org.chocosolver.solver.trace.IMessage;
import org.chocosolver.solver.variables.BoolVar;
import org.chocosolver.solver.variables.IntVar;


class Mon_message implements IMessage{
    IntVar[] _date_debut;
    IntVar[] _date_fin;
    int _nb_job;
    int _nb_machine;
    BoolVar[][] _b;
    int[][] _Tab;
    int[][] _Machine;

    Mon_message(IntVar[] date_debut, BoolVar[][] b, int nb_job, int nb_machine, int[][] Machine, int[][] Tab, IntVar[] date_fin) {
        _date_debut=date_debut;
        _nb_job=nb_job;
        _nb_machine=nb_machine;
        _date_fin=date_fin;
        _b=b;
        _Tab=Tab;
        _Machine=Machine;
    }

    public String print() {
        String ecrire=" \n --- AFFICHAGE -- \n";
        for (int i=0; i<_nb_job*_nb_machine; i++){
            if (i%_nb_machine==0){ 
                    ecrire+="\n";  // saut de ligne pour une meilleure lecture
            }
            ecrire+=_date_debut[i].toString()+ " ";
        }
        for (int i=0; i<_nb_job*_nb_machine; i++){
            if (i%_nb_machine==0){  
                ecrire+="\n";
            }
            ecrire+=_date_fin[i].toString()+ " ";
        }
        ecrire+="\n";
        for (int i=0; i<_nb_job; i++){  
            for (int j=0; j<_nb_machine; j++){
                int ope_i = _Tab[i][j];
                for (int u=0; u<_nb_job; u++){
                    if (u!=i){
                        for (int v=0; v<_nb_machine; v++){
                            int ope_u = _Tab[u][v];  
                            if (_Machine[i][j]==_Machine[u][v] && ope_u!=ope_i){
                                    ecrire+=_b[ope_i][ope_u].toString() + "  /  "; 
                            }
                        }
                    }   
                }
            }
            ecrire+="\n";
        } 
        return ecrire;  
    }
}

